import QtQuick 1.1
import com.nokia.meego 1.0
import "ucountDB.js" as UCountDB
import "Defines.js" as Defines

Page
{
    id: pageCategories
    tools: categoriesTools
    orientationLock: PageOrientation.LockPortrait
    property int listItemID:0
    UCountList
    {
        id: ucountList
        title: "Categories"
        onListItemClicked:
        {
            var page=UCountDB.getPage(UCountDB.PageType.categoriesAddEdit)
            pageStack.push(page,{categoryID: id})
        }
        onListItemPressAndHold:
        {
            listItemID=id
            menuLongPress.open()
        }
    }

    ToolBarLayout
    {
        id: categoriesTools
        visible: true
        ToolIcon
        {
            id: toolBack
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop();
        }
        ToolIcon
        {
            id: toolAdd
            platformIconId: "toolbar-add"
            anchors.right: parent.right
            onClicked:
            {
                var page=UCountDB.getPage(UCountDB.PageType.categoriesAddEdit)
                pageStack.push(page)
            }
        }
    }
	Menu
    {
        id: menuLongPress
        visualParent: pageStack
        MenuLayout
        {
            MenuItem
            {
                id: menuDelete
                text: qsTr("Delete")
				onClicked: 
				{
                    UCountDB.deleteCategory(listItemID)
                    init(PageStatus.Active)
				}				
            }			
        }
    }		
    function init(status)
    {
        if(status!==PageStatus.Active)return
        ucountList.listModel.clear()
        var list=UCountDB.readTopLevelCategories()
        for(var v in list)
        {
            var iconImage
            UCountDB.getIcon(list[v].iconid, function(info)
            {
                iconImage="qrc:/Images/"+info.qrcpath
            });
            ucountList.listModel.append({"title":list[v].name,
                                            "subtitle":list[v].description,
                                            "tableID":list[v].id,
                                            "category":"",
                                            "showDate":false,
                                            "image":iconImage,
                                            "value":0,
                                            "transactionColor":"black",
                                            "dateInserted":""})
        }
    }
    onStatusChanged: init(status)
}
