.pragma library
Qt.include("Defines.js")

/**
  *Return the budgets
  */
function readBudgets(accountID,sortType)
{
    var transactions=new Transactions()
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM budgets where accountID= ? ORDER BY dateinserted DESC",accountID);
        var item
        var transaction
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            transaction=new Transaction(item.id, parseInt(TransactionType.budget),item.accountid, item.name, item.description, item.dateinserted,parseFloat(item.value),item.categoryid,0, item.repeat)
            transactions.append(transaction)
        }
    });
    var list
    if(sortType===SortType.oneAhead) list=transactions.getListSortedWithRecurrences(true)
    else list=transactions.getListSortedWithRecurrences(false)
    if(sortType===SortType.today)return getOnlyToday(list)
    if(sortType===SortType.lastMonth)return getOnlyLastMonth(list)
    if(sortType===SortType.lastYear)return getOnlyCurrentYear(list)
    if(sortType===SortType.all)return list
    return list
}

/**
  *Return the budgets  by category
  */
function readBudgetsByCategory(accountID,startDate, endDate)
{
    var transactions=new Transactions()
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM budgets where accountid= ? ORDER BY categoryid DESC",accountID);
        var item
        var transaction
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            transaction=new Transaction(item.id, parseInt(TransactionType.budget),item.accountid, item.name, item.description, item.dateinserted,parseFloat(item.value),item.categoryid,0, item.repeat)
            transactions.append(transaction)
        }
    });
    return transactions.getCategoriesList(startDate, endDate)
}


/**
  *Get a budget specified by budgetID
  */
function getBudget(budgetID,callback)
{
    db.transaction( function(tx)
    {
       var resultSet=tx.executeSql("select * from budgets where id = ?",budgetID);
       if (resultSet.rows.length > 0)callback(resultSet.rows.item(0))
    });
}


/**
  *Save a budget
  */
function saveBudget(id, accountID, name, description, dateInserted, value, categoryID, repeat)
{
    var xID=parseInt(id)
    var xAccountID=parseInt(accountID)
    var xName=name
    var xDescription=description
    var xDateInserted
    var xValue=parseFloat(value)
    var xCategoryID=parseInt(categoryID)
    var xRepeat=parseInt(repeat)
    xDateInserted=getStringFromDateToSaveInSqlite(dateInserted)

    if(xID>0)//update
    {
        db.transaction( function(tx)
        {
            tx.executeSql("update budgets set accountid=?, name=?, description=?, dateinserted=?, value=?, categoryid=?, repeat=? where id=?",
                          [xAccountID,xName,xDescription,xDateInserted,xValue,xCategoryID,xRepeat,xID]);
        });
    }else//insert
    {
        db.transaction( function(tx)
        {
            tx.executeSql("insert into budgets (accountid, name, description, dateinserted, value, categoryid, repeat ) VALUES(?,?,?,?,?,?,?)",
                          [xAccountID,xName,xDescription,xDateInserted,xValue,xCategoryID,xRepeat]);
        });
    }
}


/**
  *Delete the budget specified by budgetID
  */
function deleteBudget(budgetID)
{
    print("removendo id: "+budgetID)
    db.transaction( function(tx)
    {
        tx.executeSql("DELETE FROM budgets where id = ?",budgetID);
    });
}
