.pragma library
Qt.include("Defines.js")

/**
  *Return the Sub categories
  */
function readSubCategories()
{
    var categoriesList = {}
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM categories where parentid > 0 ORDER BY name DESC");
        var item
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            categoriesList[item.id] = item;
        }
    });
    return categoriesList;
}


/**
  *Return all top level categories
  */
function readTopLevelCategories()
{
    var categoriesList = {}
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM categories where parentid = 0 ORDER BY name ASC");
        var item
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            categoriesList[item.id] = item;
        }
    });
    return categoriesList;
}


/**
  *Get a category specified by categoryID
  */
function getCategory(categoryID,callback)
{
    db.transaction( function(tx)
    {
       var resultSet=tx.executeSql("select * from categories where id = ?",categoryID);
       if (resultSet.rows.length > 0)callback(resultSet.rows.item(0))
       else callback(null)
    });
}


/**
  *Delete the category specified by categoryID
  */
function deleteCategory(categoryID)
{
    db.transaction( function(tx)
    {
        tx.executeSql("DELETE FROM categories where id = ?",categoryID);
    });
}


/**
  *Save a category
  */
function saveCategory(id, parentid, name, description, iconid)
{
    var xID=parseInt(id)
    var xParentID=parseInt(parentid)
    var xName=name
    var xDescription=description
    var xIconID=parseInt(iconid)

    if(xID>0)//update
    {
        db.transaction( function(tx)
        {
            tx.executeSql("update categories set parentid=?, name= ?, description= ?,  iconid= ? where id= ?",
                          [xParentID,xName,xDescription,xIconID,xID]);
        });
    }
    else//insert
    {
        db.transaction( function(tx)
        {
            tx.executeSql("insert into categories (parentid, name, description, iconid ) VALUES(?,?,?,?)",
                          [xParentID,xName,xDescription,xIconID]);
        });
    }
}
