.pragma library

var db
var SortType = {"today" : 2, "lastMonth" : 3, "lastYear": 4,"all":5, "oneAhead":6};
var TransactionType = {"expense":1, "budget":2, "transfer":3,"saving":4};
var PageType={ "expenses":1,"expensesAddEdit":2,"budgets":3,"budgetsAddEdit":4,"transfers":5,"transfersAddEdit":6,"vendors":7,"vendorsAddEdit":8,
    "accounts":9,"accountsAddEdit":10,"categoriesAddEdit":11,"categories":12,"reports":13,"preferences":21,"history":15,"preferencesPassword":16,"preferencesAbout":17,
    "preferencesHelp":18,"savings":19,"savingsAddEdit":20,"reportsResult":22};
var RepeatType={"once":1, "everyday":2, "everyweek":3,"everymonth":4,"everyyear":5};
var accountBudgetAddEdit
var accountBudgets
var accountExpenseAddEdit
var accountTransferAddEdit
var accountTransfers
var accountReports
var accountReportsResult
var accountVendorAddEdit
var accountVendors
var accountCategoriesAddEdit
var accountCategories
var accountAddEdit
var accountExpenses
var accountHistory
var accountSavings
var accountSavingsAddEdit
var pref
var preferencesAccounts
var preferencesHelp
var preferencesPassword
var preferencesAbout
var currentAccountID
var accountExpenses
var fontFamily="Nokia Pure Text"
var fontSize=16
var gridTopMargin=10
var gridLeftMargin=10
var listViewMainTextFontFamily="Nokia Pure Text"
var listViewMainTextFontSize= 30
var listViewTopItensHeight=70
var listViewTopImageSize=50

var listViewItensMainTextFontFamily="Nokia Pure Text"
var listViewItensMainTextFontSize=26
var listViewItensImageSize=50
var listViewItensHeight=65
var listViewItensSubTextFontFamily="Nokia Pure Text Light"
var listViewItensSubTextFontSize=20
var listViewItensSubTextFontColor="orange"
var listViewItensCategoryFontFamily="Nokia Pure Text Light"
var listViewItensCategoryFontSize=18
var listViewItensCategoryFontColor="orange"

var listViewTopMargin=10
var listViewLeftMargin=10
var listViewRightMargin=10

var valueFontFamily="Nokia Pure Text"
var valueFontSize=25

var defaultFontFamily="Nokia Pure Text"


/**
  *
  */
function getStringFromDateToSaveInSqlite(dateToConvert)
{
    return Qt.formatDate(dateToConvert,"yyyy/MM/dd")
}

/**
  *
  */
function getDateFromDatePickerDialog(year, month, day)
{
    var dt=new Date(year,month-1,day)
    return dt
}


/**
  *
  */
function getStartRepeat(dateInserted,repeatID)
{
    var xDate=new Date(dateInserted)
    switch(repeatID)
    {
        case RepeatType.everyday:
            xDate.setDate(xDate.getDate()+1)
            return getStringFromDate(xDate)
        case RepeatType.everyweek:
            xDate.setDate(xDate.getDate()+7)
            return getStringFromDate(xDate)
        case RepeatType.everymonth:
            xDate.setDate(xDate.getMonth()+1)
            return getStringFromDate(xDate)
        case RepeatType.everyyear:
            xDate.setDate(xDate.getFullYear()+1)
            return getStringFromDate(xDate)
    }
    return ""
}


/**
  *
  */
function getOnlyToday(list)
{
    var list2={}
    var today=new Date();//today
    today.setHours(0)
    today.setMinutes(0)
    today.setSeconds(0)
    today.setMilliseconds(0)
    var i=0
    for(var v in list)
    {
        var date= new Date(list[v].dateinserted)
        if(date - today===0)
        {
            list2[i]=list[v]
            i++
        }
    }
    return list2
}


/**
  *Return only those in the current year
  */
function getOnlyCurrentYear(list)
{
    var list2={}
    var today=new Date();//today
    var i=0
    for(var v in list)
    {
        var date= new Date(list[v].dateinserted)
        if(date.getUTCFullYear()===today.getUTCFullYear())
        {
            list2[i]=list[v]
            i++
        }
    }
    return list2
}


/**
  *Return only those until next year
  */
function getUntilNextYear(list)
{
    var list2={}
    var nextyear=new Date();
    nextyear.setFullYear(nextyear.getFullYear()+1)
    nextyear.setDate(31)
    nextyear.setMonth(11)
    var i=0
    for(var v in list)
    {
        var date= new Date(list[v].dateinserted)
        if(date.getFullYear()<=nextyear.getFullYear())
        {
            list2[i]=list[v]
            i++
        }
    }
    return list2
}


/**
  *Return only those until today
  */
function getUntilToday(list)
{
    var list2={}
    var today=new Date();
    var i=0
    today.setHours(0)
    today.setMinutes(0)
    today.setSeconds(0)
    today.setMilliseconds(0)
    for(var v in list)
    {
        var date= new Date(list[v].dateinserted)
        if(date<=today)
        {
            list2[i]=list[v]
            i++
        }
    }
    return list2
}


/**
  *Return only the transactions ocurred in this month
  */
function getOnlyLastMonth(list)
{
    var list2={}
    var today=new Date();//today
    var i=0
    for(var v in list)
    {
        var date= new Date(list[v].dateinserted)
        if(date.getUTCFullYear()===today.getUTCFullYear()&& date.getUTCMonth()===today.getUTCMonth())
        {
            list2[i]=list[v]
            i++
        }
    }
    return list2
}



/**
  *
  */
function sortBla(a, b)
{
    var dateA= new Date(a.dateinserted)
    var dateB= new Date(b.dateinserted)
    var result= ((dateA < dateB) ? 1 : ((dateA > dateB) ? -1 : 0));
    return (result)
}


function Transactions()
{
    this.list=new Array()
}

Transactions.prototype.append = function(transaction)
{
    this.list.push(transaction)
}

Transactions.prototype.getCategoriesList = function(startDate, endDate)
{
    var list=this.getListSortedWithRecurrences()
    var categoriesList=new Array()
    startDate.setHours(0)
    startDate.setMinutes(0)
    startDate.setSeconds(0)
    startDate.setMilliseconds(0)
    endDate.setHours(0)
    endDate.setMinutes(0)
    endDate.setSeconds(0)
    endDate.setMilliseconds(0)
    for(var v=0;v<list.length;v++)
    {
        var transaction=list[v]
        var dt=new Date(transaction.dateinserted)
        if(dt<startDate || dt>endDate)continue
        if(v==0)
        {
            var newTransaction=new Transaction(transaction.id, transaction.transactionType, transaction.accountid,transaction.name,
                                                   transaction.description,Qt.formatDate(transaction.dateinserted,"yyyy/MM/dd"),transaction.value,
                                                    transaction.categoryid,transaction.vendorid,transaction.repeat)
            categoriesList.push(newTransaction)
        }else
        {
            var found=false
            for(var x=0;x<categoriesList.length;x++)
            {
                if(parseInt(transaction.categoryid)===parseInt(categoriesList[x].categoryid))
                {
                    categoriesList[x].value+=transaction.value
                    found=true
                    break
                }
            }
            if(!found)
            {
                var newTransaction1=new Transaction(transaction.id, transaction.transactionType, transaction.accountid,transaction.name,
                                                       transaction.description,Qt.formatDate(transaction.dateinserted,"yyyy/MM/dd"),transaction.value,
                                                        transaction.categoryid,transaction.vendorid,transaction.repeat)
                categoriesList.push(newTransaction1)
            }
        }
    }
    return categoriesList
}


/**
  *
  */
Transactions.prototype.getListSortedWithRecurrences = function(untilNextYear)
{
    var listToReturn=new Array()
    for(var v in this.list)
    {
        var transaction=this.list[v]
        var transactionInsertedDate=new Date(transaction.dateinserted)
        var currentDate=new Date()
        currentDate.setHours(0)
        currentDate.setMinutes(0)
        currentDate.setSeconds(0)
        currentDate.setMilliseconds(0)
        if(untilNextYear)
        {
            currentDate.setFullYear(currentDate.getFullYear()+1)
            currentDate.setDate(31)
            currentDate.setMonth(11)
        }
        if(transactionInsertedDate>currentDate)continue
        switch(parseInt(transaction.repeat))
        {
            case RepeatType.once:
                listToReturn.push(transaction)
                break
            case RepeatType.everyday:
                for(var dt=transactionInsertedDate;dt<=currentDate;dt.setDate(dt.getDate()+1))
                {
                    var newTransaction=new Transaction(this.list[v].id, this.list[v].transactionType, this.list[v].accountid, this.list[v].name,
                                                            this.list[v].description,Qt.formatDate(dt,"yyyy/MM/dd"), this.list[v].value, this.list[v].categoryid, this.list[v].vendorid, this.list[v].repeat)
                    listToReturn.push(newTransaction)
                }
                break
            case RepeatType.everyweek:
                for(var dtWeek=transactionInsertedDate;dtWeek<=currentDate;dtWeek.setDate(dtWeek.getDate()+7))
                {
                    var newTransactionWeek=new Transaction(this.list[v].id, this.list[v].transactionType, this.list[v].accountid, this.list[v].name,
                                                            this.list[v].description,Qt.formatDate(dtWeek,"yyyy/MM/dd"), this.list[v].value, this.list[v].categoryid, this.list[v].vendorid, this.list[v].repeat)
                    listToReturn.push(newTransactionWeek)
                }
                break
            case RepeatType.everymonth:
                for(var dtMonth=transactionInsertedDate;dtMonth<=currentDate;dtMonth.setMonth(dtMonth.getMonth()+1))
                {
                    var newTransactionMonth=new Transaction(this.list[v].id, this.list[v].transactionType, this.list[v].accountid, this.list[v].name,
                                                            this.list[v].description,Qt.formatDate(dtMonth,"yyyy/MM/dd"), this.list[v].value, this.list[v].categoryid, this.list[v].vendorid, this.list[v].repeat)
                    listToReturn.push(newTransactionMonth)
                }
                break
            case RepeatType.everyyear:
                for(var dtYear=transactionInsertedDate;dtYear<=currentDate;dtYear.setFullYear(dtYear.getFullYear()+1))
                {
                    var newTransactionYear=new Transaction(this.list[v].id, this.list[v].transactionType, this.list[v].accountid, this.list[v].name,
                                                            this.list[v].description,Qt.formatDate(dtYear,"yyyy/MM/dd"), this.list[v].value, this.list[v].categoryid, this.list[v].vendorid, this.list[v].repeat)
                    listToReturn.push(newTransactionYear)
                }
                break       
        }
    }
    listToReturn.sort(sortBla)
    return listToReturn
}


Transactions.prototype.sortByDate = function()
{
    this.list.sort(sortBla)
}

function Transaction(transactionID, transactionType, accountID, name, description, dateInserted, value, categoryID, vendorID, repeat)
{
    this.id = transactionID;
    this.transactionType=transactionType
    this.accountid = accountID;
    this.name = name;
    this.description = description;
    this.dateinserted = dateInserted;
    this.value= value
    this.categoryid=categoryID
    this.vendorid=vendorID
    this.repeat=repeat
}

Transaction.prototype.getInfo = function()
{
    return this.name;
};
