import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "Defines.js" as Defines
import "ucountDB.js" as UCountDB

Page
{
    id: pageLogin
    orientationLock: PageOrientation.LockPortrait
    PageTitle
    {
        id: pageTitle
        title: "Login"
    }
    Rectangle
    {
        id: rect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: pageTitle.bottom
        anchors.bottom: parent.verticalCenter
        color: "#5958a2"
    }
    Label
    {
        anchors.verticalCenter: rect.verticalCenter
        anchors.horizontalCenter: rect.horizontalCenter
        text:"Welcome to UCount\nPlease type your password below"
        color: "white"
        font.family: Defines.defaultFontFamily
        font.pointSize: 20
    }

    TextField
    {
        id: txt
        anchors.top: rect.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.rightMargin: 10
        anchors.leftMargin: 10
        echoMode: TextInput.Password
    }
    Button
    {
        id: btnLogin
        text: "Login"
        width: 200
        style: PositiveButtonStyle {}
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: txt.bottom
        anchors.topMargin: 30
        onClicked: tryLogin()
    }
    Label
    {
        id: lblError
        font.family: Defines.defaultFontFamily
        font.pointSize: 20
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: btnLogin.bottom
        anchors.topMargin: 30
        text:"Invalid password"
        color: "red"
        visible: false
    }

    function tryLogin()
    {
        lblError.visible=false
        var pass=Qt.md5(txt.text)
        var result=UCountDB.tryLogin(pass)
        if(result)appWindow.openFile("MainPage.qml")
        else
        {
            lblError.visible=true
            txt.text=""
        }
    }
}
