import QtQuick 1.0
import com.nokia.meego 1.0
import "Defines.js" as Defines

Rectangle
{
    width: parent.width
    height: 60
    property alias title: lblTitle.text
    property alias subtitle: lblSubTitle.text
    property alias btnDoneVisible: toolDone.visible
    property alias btnCancelVisible: toolCancel.visible
    property alias accountName: lblAccountName.text
    property alias lblAccountVisible: lblAccountName.visible
    signal cancelled()
    signal done()
    color: "orange"
    Text
    {
        id: lblTitle
        text: qsTr("text")
        font.family: Defines.defaultFontFamily
        font.pointSize: 18
        font.bold: true
        color: "white"
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: parent.left
        anchors.leftMargin: 10
    }
    Text
    {
        id: lblAccountName
        text: qsTr("text")
        font.family: Defines.defaultFontFamily
        font.pointSize: 18
        //font.bold: true
        color: "white"
        anchors.verticalCenter: parent.verticalCenter
        anchors.right: parent.right
        anchors.rightMargin: 25
        visible: false
    }
    Text
    {
        anchors.top: lblTitle.bottom
        font.family: Defines.defaultFontFamily
        id: lblSubTitle
        text:" "
        color: "white"
        anchors.left: parent.left
        anchors.leftMargin: 10
    }
    Progress
    {
        id: progressBudget
        anchors.left: lblTitle.right
        anchors.right: parent.right
        anchors.leftMargin: 10
        minimum: 0
        maximum: 100
        height: parent.height
        color: "green"
        visible: false
    }
    Progress
    {
        id: progressExpense
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: lblTitle.right
        anchors.right: parent.right
        anchors.leftMargin: 10
        minimum: 0
        maximum: 100
        height: parent.height
        color: "red"
        visible: false
    }
    Progress
    {
        id: progressTransfer
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: lblTitle.right
        anchors.right: parent.right
        anchors.leftMargin: 10
        minimum: 0
        maximum: 100
        height: parent.height
        color: "blue"
        visible: false
    }
    Progress
    {
        id: progressSaving
        anchors.verticalCenter: parent.verticalCenter
        anchors.left: lblTitle.right
        anchors.right: parent.right
        anchors.leftMargin: 10
        minimum: 0
        maximum: 100
        height: parent.height
        color: "yellow"
        visible: false
    }
    ToolIcon
    {
        id: toolCancel
        platformIconId: "toolbar-undo"
        anchors.right: toolDone.left
        visible: false
        anchors.verticalCenter: parent.verticalCenter
        onClicked: cancelled()
    }
    ToolIcon
    {
        id: toolDone
        platformIconId: "toolbar-done"
        anchors.right: parent.right
        visible: false
        anchors.verticalCenter: parent.verticalCenter
        onClicked: done()
    }
    function showProgress(budgetSum, expenseSum,transferSum, savingsSum)
    {
        if(!expenseSum)progressExpense.visible=false
        if(!budgetSum)progressBudget.visible=false
        if(!savingsSum)progressSaving.visible=false
        if(!transferSum)progressTransfer.visible=false

        if(budgetSum===expenseSum && budgetSum>0 && expenseSum>0)
        {
            progressBudget.maximum=budgetSum
            progressBudget.value=budgetSum
            progressBudget.display=0
            progressBudget.visible=true
            progressBudget.color="steelblue"
            progressBudget.showText=true
            progressExpense.visible=false
            return
        }
        var larguraBudget
        var larguraExpense
        if(budgetSum)
        {
            if(budgetSum<expenseSum)
            {
                progressBudget.maximum=100
                progressBudget.value=Math.floor(budgetSum*100/expenseSum)
                progressBudget.display=budgetSum
                progressBudget.visible=true;
                progressBudget.z=50
                progressBudget.color="green"
            }
            if(budgetSum>expenseSum)
            {
                progressBudget.maximum=budgetSum
                progressBudget.value=budgetSum
                progressBudget.display=budgetSum
                progressBudget.visible=true
                progressBudget.z=10
                progressBudget.color="green"
                progressBudget.showText=true
            }
            larguraBudget=((460 * (progressBudget.value)) / (progressBudget.maximum) - 6)
            if(larguraBudget>70)progressBudget.showText=true
            else progressBudget.showText=false
        }
        if(expenseSum)
        {
            if(budgetSum<expenseSum)
            {
                progressExpense.maximum=expenseSum
                progressExpense.value=expenseSum
                progressExpense.display=expenseSum
                progressExpense.visible=true
                progressExpense.z=10
                progressExpense.showText=true
            }
            if(budgetSum>expenseSum)
            {
                progressExpense.maximum=100
                progressExpense.value=Math.floor(expenseSum*100/budgetSum)
                progressExpense.display=expenseSum
                progressExpense.visible=true;
                progressExpense.z=50
            }
            larguraExpense=((460 * (progressExpense.value)) / (progressExpense.maximum) - 6)
            if(larguraExpense>70)progressExpense.showText=true
            else progressExpense.showText=false
        }
        //lets see if we need to hide the text on the right
        if(budgetSum>0 && expenseSum>0)
        {
            if(budgetSum>expenseSum && ((larguraBudget-larguraExpense)<70 ))progressBudget.showText=false
            if(expenseSum>budgetSum && ((larguraExpense-larguraBudget)<70))progressExpense.showText=false
        }

        if(transferSum)
        {
            progressTransfer.value=Math.floor((transferSum*100) / (transferSum))
            progressTransfer.display=transferSum
            progressTransfer.visible=true
        }
        if(savingsSum)
        {
            progressSaving.value=Math.floor((savingsSum*100) / (savingsSum))
            progressSaving.display=savingsSum
            progressSaving.visible=true
        }
    }
}
