import QtQuick 1.1
import com.nokia.meego 1.0
import "ucountDB.js" as UCountDB
import "Defines.js" as Defines

Page
{
    id: aboutPage
    tools: aboutTools
    orientationLock: PageOrientation.LockPortrait
    property int fontSize:15

    PageTitle
    {
        id: pageTitle
        title: "About"
    }
    Column
    {
        id: column
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.verticalCenter: parent.verticalCenter
        //anchors.horizontalCenter: parent.horizontalCenter
        Text
        {
            id: lblVersion
            font.family: Defines.defaultFontFamily
            font.pointSize: fontSize
            text: qsTr("Copyright 2011 Tezine Technologies")
            anchors.horizontalCenter: parent.horizontalCenter
        }
        Text
        {
            id: lblAbout
            font.family: Defines.defaultFontFamily
            font.pointSize: fontSize
            text: qsTr("Copyright 2011 Tezine Technologies")
            anchors.horizontalCenter: parent.horizontalCenter
        }
        Text
        {
            id: lblFeedBack
            font.family: Defines.defaultFontFamily
            font.pointSize: fontSize
            text: qsTr("Please send feedbacks to contact@tezine.com")
            anchors.horizontalCenter: parent.horizontalCenter
        }
    }

    ToolBarLayout
    {
        id: aboutTools
        visible: true
        ToolIcon
        {
            id: toolBack
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop();
        }
    }
    function init()
    {
        lblVersion.text="UCount "+UCountDB.getVersion()
    }

    Component.onCompleted:  init()
}
