import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "ucountDB.js" as UCountDB
import "Defines.js" as Defines

Page
{
    id: accountAddEditPage
    orientationLock: PageOrientation.LockPortrait
    property int accountID: 0
    property int secondColumnWidth: 360

    PageTitle
    {
        id: pageTitle
        title: "New Account"
        btnDoneVisible: true
        btnCancelVisible: true
        onCancelled:  pageStack.pop()
        onDone: saveAccount()
    }

    Grid
    {
        columns: 2
        spacing: 2
        anchors.top: pageTitle.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        anchors.leftMargin: 10
        anchors.topMargin: UCountDB.gridTopMargin
        clip: true
        Text
        {
            id: lblName
            font.family: Defines.fontFamily
            font.pointSize: Defines.fontSize
            text: qsTr("Name")
            anchors.verticalCenter: txtName.verticalCenter
        }
        TextField
        {
            id: txtName
            width: secondColumnWidth
        }
        Text
        {
            id: lblDescription
            font.family: Defines.fontFamily
            font.pointSize: Defines.fontSize
            text: qsTr("Note")
            anchors.verticalCenter: txtDescription.verticalCenter
        }
        TextField
        {
            id: txtDescription
            width: secondColumnWidth
        }
        Text
        {
            id: lblDefaultAccount
            font.family: Defines.fontFamily
            font.pointSize: Defines.fontSize
            text: qsTr("Current")
            anchors.verticalCenter: switchDefault.verticalCenter
        }
        Switch
        {
            id: switchDefault
            anchors.right: txtDescription.right
        }
    }
    function saveAccount()
    {        
        UCountDB.saveAccount(accountID, txtName.text,txtDescription.text,switchDefault.checked)
        pageStack.pop()
    }
    function getAccount()
    {
        if(accountID==0)return
        UCountDB.getAccount(accountID, function(info)
        {
            pageTitle.title="Edit Account"
            txtName.text=info.name
            txtDescription.text=info.description                                                                
            if(info.defaultaccount)
            {
                switchDefault.checked=true
                lblDefaultAccount.enabled=false
                switchDefault.enabled=false
            }
            else switchDefault.checked=false
        });
    }
    Component.onCompleted:  getAccount()
}
