import QtQuick 1.1
import com.nokia.meego 1.0
import "ucountDB.js" as UCountDB
import "Defines.js" as Defines

Page
{
    id: prefAccountsPage
    tools: prefAccountsTools
    orientationLock: PageOrientation.LockPortrait
    property int listItemID:0
    UCountList
    {
        id: ucountList
        title: "Accounts"
        onListItemClicked:
        {
            var page=UCountDB.getPage(UCountDB.PageType.accountsAddEdit)
            pageStack.push(page,{accountID: id})
        }
        onListItemPressAndHold:
        {
            listItemID=id
            var defaultAccount=false
            UCountDB.getAccount(listItemID, function(info)
            {
                if(info.defaultaccount)defaultAccount=true
            });
            if(!defaultAccount)menuLongPress.open()
        }
    }
    ToolBarLayout
    {
        id: prefAccountsTools
        visible: true
        ToolIcon
        {
            id: toolBack
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop();
        }
        ToolIcon
        {
            id: toolAdd
            platformIconId: "toolbar-add"
            anchors.right: parent.right
            onClicked:
            {
                var page=UCountDB.getPage(UCountDB.PageType.accountsAddEdit)
                pageStack.push(page)
            }
        }
    }
    Menu
    {
        id: menuLongPress
        visualParent: pageStack
        MenuLayout
        {
            MenuItem
            {
                id: menuDelete
                text: qsTr("Delete")
                onClicked:
                {
                    UCountDB.deleteAccount(listItemID)
                    init(PageStatus.Active)
                }
            }
        }
    }
    ErrorDialog
    {
        id: errorDialog
    }
    function init(status)
    {
        if(status!==PageStatus.Active)return
        ucountList.listModel.clear()
        var list=UCountDB.readAccounts()
        for(var v in list)
        {
            ucountList.listModel.append({"title":list[v].name,
                                            "subtitle":list[v].description,
                                            "image":list[v].image,
                                            "value":0,
                                            "category":"",
                                            "dateInserted":"",
                                            "showDate":false,
                                            "transactionColor":"black",
                                            "tableID":list[v].id})
        }
    }
    onStatusChanged: init(status)
}
