import QtQuick 1.1
import com.nokia.meego 1.0
import "ucountDB.js" as UCountDB

Page
{
    id: prefExpensePage
    tools: prefExpenseTools   
    orientationLock: PageOrientation.LockPortrait

    PageTitle
    {
        id: pageTitle
        title: "Expenses"
    }

    Grid
    {
        columns: 2
        spacing: 2
        anchors.top: pageTitle.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.leftMargin: 10
        Text
        {
            id: lblVat
            font.family: "Helvetica"
            font.pointSize: 16
            text: qsTr("Vat")
            anchors.left: parent.left
        }
        Switch
        {
            id: switchVat
            anchors.right: parent.right
        }
        Text
        {
            id: lblVendor
            font.family: "Helvetica"
            font.pointSize: 16
            text: qsTr("Vendor")
            anchors.left: parent.left
        }
        Switch
        {
            id: switchVendor
            anchors.right: parent.right
        }
        Text
        {
            id: lblCollapsed
            font.family: "Helvetica"
            font.pointSize: 16
            text: qsTr("Collapsed")
            anchors.left: parent.left
        }
        Switch
        {
            id: switchCollapsed
            anchors.right: parent.right
        }
    }
    ToolBarLayout
    {
        id: prefExpenseTools
        visible: true
        ToolIcon
        {
            id: toolBack
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop();
        }
    }		
}
