import QtQuick 1.1
import com.nokia.meego 1.0
import "ucountDB.js" as UCountDB

Page
{
    id: helpPage
    tools: helpTools
    orientationLock: PageOrientation.LockPortrait
    PageTitle
    {
        id: pageTitle
        title: "Help"
    }
    Flickable
    {
        id:flick
        anchors.top: pageTitle.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        contentWidth: parent.width
        contentHeight: 2400
        clip: true
        TextArea
        {
            anchors.fill: parent
            readOnly: true
            text: "<b>Overview</b><br/> \
            UCount is designed to be a Personal Expense and Budget Tracking Tool. It has the basic functionality to control your finance divided into categories, accounts and vendors.  \
            UCount also provides password protected login and it allows you to transfer between accounts or into your <i>Savings</i>.<br/><br/> \
            <b>History</b><br/> \
            <i>History</i> shows all your expenses and budgets from within a period, which can be a month, day, year, all until today or the expenses and budgets for the next year<br/> \
            The total is displayed in the bottom of the screen. <br/><br/> \
           <b>Expenses</b><br/> \
           <i>Expenses</i> shows all your expenses from within a period. The total is displayed in the bar on the top.<br/><br/> \
           <b>Budgets</b><br/> \
            <i>Budgets</i> shows all your income from within a period. The total is displayed in the bar on the top.<br/><br/> \
           <b>Transfers</b><br/> \
            <i>Transfers</i> allows you to transfer money from one account to another or to <i>Savings</i>, which is in the current account. <br/> \
            If you choose to transfer to another account, the amount transfered will be withdrawn from the current account( Appears as expense ) and sent to the other account( Appear as budget ). <br/> \
            If you choose to transfer to <i>Savings</i>, the amount transfered will be withdrawn from the current account and it will appear inside <i>Savings</i>. <br/><br/> \
           <b>Categories</b><br/> \
            <i>Categories</i> allows you to group your expenses, budgets, transfers and savings so you can generate reports. <br/><br/> \
           <b>Reports</b><br/> \
            <i>Reports</i> shows your expenses, budgets, transfers and savings divided into categories within a period. The sum of each category is presented as a bar. <br/><br/> \
           <b>Vendors</b><br/> \
            <i>Vendors</i> allows you to fine tune your expense. When you select a vendor into a new expense, UCount picks the vendor's category automatically for you. <br/><br/> \
           <b>Savings</b><br/> \
            <i>Savings</i> allows you to track the amount saved within a period. There are two ways you may add a <i>Saving</i>. You can press the plus button inside <i>Savings</i> or you can \
            transfer from your account to <i>Savings</i>. If you choose to transfer, the amount transfered will be withdrawn from your account and will appear as <i>Expense</i>. <br/><br/> \
           <b>Password</b><br/> \
            <i>Password</i> allows you to protect your UCount, so anybody must enter a password to Log in before the main screen is presented. Please notice that if you set a password, there's no way to recover it if you lost it. <br/><br/> \
           <b>Accounts</b><br/> \
            <i>Accounts</i> allows to one user track several bank/credit accounts in the same application or to have one account for each user. For instance, you may have one account named <i>Child</i> to keep
            track of your child expenses, and another account named <i>MySelf</i> to keep track of your own transactions. <br/><br/> \
           <b>Database</b><br/> \
            All records are saved a database inside your mobile. If you need to clear all your data, you can reset the database by pressing <i>Clean Database</i> inside Preferences."
        }
    }
    ScrollDecorator
    {
        id: scrollDecorator
        flickableItem: flick
    }
    Rectangle
    {
        anchors.fill: flick
        border.color: "#333"
        color: "transparent"
    }
    ToolBarLayout
    {
        id: helpTools
        visible: true
        ToolIcon
        {
            id: toolBack
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop();
        }
    }
}
