import QtQuick 1.1
import com.nokia.meego 1.0
import "ucountDB.js" as UCountDB

Page
{
    id: prefHistoryPage
    tools: prefHistoryTools
    orientationLock: PageOrientation.LockPortrait
    PageTitle
    {
        id: pageTitle
        title: "History"
    }


    Grid
    {
        id: gridHistory
        columns: 2
        spacing: 2
        anchors.top: pageTitle.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.leftMargin: 10
        Text
        {
            id: lblShowBar
            font.family: "Helvetica"
            font.pointSize: 16
            text: qsTr("Show Bar")
            anchors.left: parent.left
        }
        Switch
        {
            id: switchShowBar
            anchors.right: parent.right
        }
        Text
        {
            id: lblShowCollapsed
            font.family: "Helvetica"
            font.pointSize: 16
            text: qsTr("Show Collapsed")
            anchors.left: parent.left
        }
        Switch
        {
            id: switchShowCollapsed
            anchors.right: parent.right
        }
    }
    ListModel
    {
        id: pagesModel
        ListElement
        {
            title: "Sort by"
            page: "PreferencesHistorySort.qml"
            image: "qrc:/Images/arrow.png"
            //subtitle: "Buttons, TextField, ToolBar and ViewMenu"
        }
        ListElement
        {
            title: "Collapsed Itens"
            page: "PreferencesHistoryCollapsedItens.qml"
            image: "qrc:/Images/arrow.png"
            //subtitle: "How to use different dialogs"
        }
        ListElement
        {
            title: "Uncollapsed Itens"
            page: "PreferencesHistoryUncollapsedItens.qml"
            image: "qrc:/Images/arrow.png"
            //subtitle: "How to use different dialogs"
        }
    }

    ListView
    {
            id: listView
            anchors.top: gridHistory.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom
            anchors.leftMargin: 10
            model: pagesModel

            delegate:  Item
            {
                id: listItem
                height: 70
                width: parent.width

                BorderImage
                {
                    id: background
                    anchors.fill: parent
                    // Fill page borders
                    anchors.leftMargin: -mainPage.anchors.leftMargin
                    anchors.rightMargin: -mainPage.anchors.rightMargin
                    visible: mouseArea.pressed
                    //source: "qrc:/Images/preferences.png"
                }
                Row
                {
                    anchors.fill: parent
                    anchors.leftMargin: 0
                    Column
                    {
                        anchors.verticalCenter: parent.verticalCenter

                        Label
                        {
                            id: mainText
                            text: model.title
                            font.family: "Helvetica"
                            font.pointSize: 16
                        }

                        Label
                        {
                            id: subText
                            //text: model.subtitle
                            font.weight: Font.Light
                            font.pixelSize: 22
                            color: "#cc6633"
                            visible: text != ""
                        }
                    }
                }
                Image
                {
                    id: imagem
                    source: model.image
                    anchors.right: parent.right;
                    anchors.verticalCenter: parent.verticalCenter
                    anchors.margins: 25
                }
                MouseArea
                {
                    id: mouseArea
                    anchors.fill: background
                    onClicked: appWindow.openFile(page)
                }
            }
        }
        ScrollDecorator
        {
            flickableItem: listView
        }

    ToolBarLayout
    {
        id: prefHistoryTools
        visible: true
        ToolIcon
        {
            id: toolBack
            platformIconId: "toolbar-back"
            anchors.left: parent.left
            onClicked: pageStack.pop();
        }
    }
}

