.pragma library
Qt.include("Defines.js")

/**
  *Return the savings
  */
function readSavings(accountID,sortType)
{
    var list = {}
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM savings where accountid= ? ORDER BY name asc",accountID);
        var item
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            item.value=parseFloat(item.value)
            list[item.id] = item;
        }
    });
    if(sortType===SortType.oneAhead)return getUntilNextYear(list)
    if(sortType===SortType.today)return getOnlyToday(list)
    if(sortType===SortType.lastMonth)return getOnlyLastMonth(list)
    if(sortType===SortType.lastYear)return getOnlyCurrentYear(list)
    if(sortType===SortType.all)return getUntilToday(list)
    return list
}


/**
  *Return the savings  by category
  */
function readSavingsByCategory(accountID,startDate, endDate)
{
    var transactions=new Transactions()
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM savings where accountid= ? ORDER BY categoryid DESC",accountID);
        var item
        var transaction
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            transaction=new Transaction(item.id, parseInt(TransactionType.saving),item.accountid, item.name, item.description, item.dateinserted,parseFloat(item.value),item.categoryid,0, RepeatType.once)
            transactions.append(transaction)
        }
    });
    return transactions.getCategoriesList(startDate, endDate)
}


/**
  *Get a saving specified by savingID
  */
function getSaving(savingID,callback)
{
    db.transaction( function(tx)
    {
       var resultSet=tx.executeSql("select * from savings where id = ?",savingID);
       if (resultSet.rows.length > 0)callback(resultSet.rows.item(0))
    });
}


/**
  *Delete the saving specified by savingID
  */
function deleteSaving(savingID)
{
    db.transaction( function(tx)
    {
        tx.executeSql("DELETE FROM savings where id = ?",savingID);
    });
}

/**
  *Save a saving
  */
function saveSaving(id, accountID, name, description, dateInserted, value, categoryID)
{
    var xID=parseInt(id)
    var xAccountID=parseInt(accountID)
    var xName=name
    var xDescription=description
    var xDateInserted
    var xValue=parseFloat(value)
    var xCategoryID=parseInt(categoryID)
    xDateInserted=getStringFromDateToSaveInSqlite(dateInserted)

    if(xID>0)//update
    {
        db.transaction( function(tx)
        {
            tx.executeSql("update savings set accountid=?, name= ?, description= ?, dateinserted= ?, value=?, categoryid=?  where id= ?",
                          [xAccountID, xName,xDescription,xDateInserted,xValue,xCategoryID, xID]);
        });
    }
    else//insert
    {
        db.transaction( function(tx)
        {
            tx.executeSql("insert into savings ( accountid, name, description, dateinserted, value, categoryid ) VALUES(?,?,?,?,?,?)",
                          [xAccountID, xName,xDescription,xDateInserted,xValue,xCategoryID]);
        });
    }
}
