.pragma library
Qt.include("Defines.js")

/**
  *Return the vendors
  */
function readVendors()
{
    var list = {}
    db.readTransaction( function(tx)
    {
        var rs = tx.executeSql("SELECT * FROM vendors ORDER BY name asc");
        var item
        for (var i=0; i< rs.rows.length; i++)
        {
            item = rs.rows.item(i)
            list[item.id] = item;
        }
    });
    return list;
}

/**
  *Get a vendor specified by vendorID
  */
function getVendor(vendorID,callback)
{
    db.transaction( function(tx)
    {
       var resultSet=tx.executeSql("select * from vendors where id = ?",vendorID);
       if (resultSet.rows.length > 0)callback(resultSet.rows.item(0))
    });
}


/**
  *Delete the vendor specified by vendorID
  */
function deleteVendor(vendorID)
{
    db.transaction( function(tx)
    {
        tx.executeSql("DELETE FROM vendors where id = ?",vendorID);
    });
}


/**
  *Save a vendor
  */
function saveVendor(id, name, description, categoryID)
{
    var xID=parseInt(id)
    var xName=name
    var xDescription=description
    var xCategoryID=parseInt(categoryID)

    if(xID>0)//update
    {
        db.transaction( function(tx)
        {
            tx.executeSql("update vendors set name= ?, description= ?, categoryid= ? where id= ?",
                          [xName,xDescription,xCategoryID,xID]);
        });
    }
    else//insert
    {
        db.transaction( function(tx)
        {
            tx.executeSql("insert into vendors ( name, description, categoryid ) VALUES(?,?,?)",
                          [ xName,xDescription,xCategoryID]);
        });
    }
}
